<?php

/*
login.php
Copyright 2005 Lorne McIntosh
www.lorneswork.com
*/

require 'cgi-bin/calendar.php';
require 'cgi-bin/formProcessor.php';
require 'cgi-bin/db_connect.php';

if($logged_in)
{
	//already logged in - redirect to index
	header('Location: index.php');
}

function checkUsername()
{
	require 'cgi-bin/db_connect.php';
	global $usersTable;

	//check username is valid
	if(!ereg("^[a-z0-9]{4,16}$", $_POST['username']))
	{
		return false;
	}
	else
	{
		$check = $db_object->query("SELECT * FROM " . $usersTable . " WHERE username = '" . $_POST['username'] . "'");
		$db_object->disconnect();
		if (DB::isError($check) || $check->numRows() <= 0)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}

function checkPassword()
{
	require 'cgi-bin/db_connect.php';
	global $usersTable;

	// check password is valid
	if(!ereg("^[a-z0-9]{6,16}$", $_POST['password']))
	{
		return false;
	}
	else
	{
		$check = $db_object->query("SELECT * FROM " . $usersTable . " WHERE username = '" . $_POST['username'] . "' AND password = '" . $_POST['password'] . "'");
		$db_object->disconnect();
		if (DB::isError($check) || $check->numRows() != 1)
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}

$formML = '
<form action="' . $_SERVER['PHP_SELF'] . '" method="post">
<errorlist>
<ul>
<erroritem> <li><message /></li>
</erroritem></ul>
</errorlist>

<label for="username">Username: </label>
<input type="text" name="username" id="username" compulsory="yes" callback="checkUsername" maxlength="16" size="20"/>
<error for="username"> <strong class="error">!</strong></error>
<errormsg field="username" test="compulsory">You must enter your username</errormsg>
<errormsg field="username" test="callback">Username does not exist</errormsg>
<br/>

<label for="password">Password: </label>
<input type="password" name="password" id="password" compulsory="yes" callback="checkPassword" maxlength="16" size="20"/>
<error for="password"> <strong class="error">!</strong></error>
<errormsg field="password" test="compulsory">You must enter your password</errormsg>
<errormsg field="password" test="callback">Password was incorrect</errormsg>

<p>
<input type="submit" value="Login" />
</p>
</form>
';
$processor = new FormProcessor($formML);
if ($processor->validate())
{
	//get user info for session
	$select = $db_object->query("SELECT * FROM " . $usersTable . " WHERE username = '" . $_POST['username'] . "' AND password = '" . $_POST['password'] . "'");
	$info = $select->fetchRow();

	//register session variables
	$_SESSION['id'] = $info['id'];
	$_SESSION['username'] = $info['username'];
	$_SESSION['password'] = $info['password'];
	$_SESSION['regdate'] = $info['regdate'];
	$_SESSION['tz'] = $info['tz'];
	$_SESSION['lastip'] = $info['lastip'];
	$_SESSION['lastdate'] = $info['lastdate'];

	//update last IP address and last date
	$update = $db_object->query(
						"UPDATE ".$usersTable."
						SET lastip=INET_ATON('".$REMOTE_ADDR."'),
						lastdate='".gmdate("Y-m-d")."'
						WHERE id='".$_SESSION['id']."'");
	$db_object->disconnect();
	if (DB::isError($update))
	{
		die($update->getMessage());
	}

	//logged in - redirect user
	header('Location: index.php');
}
else
{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title><?php include 'cgi-bin/name.inc.php'; ?> - Login</title>
<link rel="stylesheet" type="text/css" href="shared.css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body onload="document.forms[0].elements[0].focus();">
<table width="100%" height="100%" border="0" align="center"> 
  <tr> 
    <td align="center" valign="middle"> <table width="560" border="0" cellpadding="8" cellspacing="0"> 
        <tr align="left" bordercolor="#000099" bgcolor="#DBEAF5"> 
          <td valign="middle" bordercolor="#000099"><strong class="title"><?php include 'cgi-bin/name.inc.php'; ?></strong></td> 
          <td align="right" valign="bottom" bordercolor="#000099"><a href="register.php">Create an account...</a></td> 
        </tr> 
      </table> 
      <table width="560" height="200" border="1" align="center" cellpadding="8" cellspacing="0" bordercolor="#000099" bgcolor="#DBEAF5"> 
        <tr align="center" valign="middle" bgcolor="#000099"> 
          <td colspan="2"> <font color="#FFFFFF" style="font-weight:bold"> 
            <?php
			dispDate();
			?> 
            </font></td> 
        </tr> 
        <tr> 
          <td width="240" height="100%" align="center" valign="middle"> <div id="miniCalendar"> 
              <?php
			$miniCal = new WebCalendar(true, true, 0);
			$miniCal->dispMonthTitle();
			$miniCal->dispMonth();
			?> 
          </div></td> 
          <td height="100%" align="right" valign="bottom"><div align="center"><strong>Login to <?php include 'cgi-bin/name.inc.php'; ?>:</strong></div>
<?php
    //show the form
	$processor->display();
?>        </tr> 
        <tr align="center" valign="middle"> 
          <td colspan="2"><?php include 'cgi-bin/footer.inc.php'; ?></td> 
        </tr> 
      </table></td> 
  </tr> 
</table> 
</body>
</html>
<?php
}
?>