<?php

/*
event.php
Copyright 2005 Lorne McIntosh
www.lorneswork.com
*/

require 'cgi-bin/calendar.php';
require 'cgi-bin/formProcessor.php';
require 'cgi-bin/db_connect.php';

if(!$logged_in)
{
	//not logged in - redirect to index
	header('Location: index.php');
}
else
{
	//if id is passed, we must be editing - set page name accordingly
	if(isset($_POST['id'])) {$pageName = "Edit Event";} else {$pageName = "Add a New Event";}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title><?php include 'cgi-bin/name.inc.php'; echo " - " . $pageName; ?></title>
<link rel="stylesheet" type="text/css" href="shared.css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body onload="document.forms[0].elements[0].focus();">
<table width="100%" height="100%" border="0" align="center"> 
  <tr> 
    <td align="center" valign="middle"> <table width="100%" height="100%" border="1" align="center" cellpadding="8" cellspacing="0" bordercolor="#000099" bgcolor="#DBEAF5"> 
        <tr align="left" bordercolor="#000099" bgcolor="#DBEAF5"> 
          <td valign="middle" bordercolor="#000099"><strong class="title"><?php include 'cgi-bin/name.inc.php'; ?></strong></td> 
        </tr> 
        <tr align="center" valign="middle" bgcolor="#000099"> 
          <td><font color="#FFFFFF" style="font-weight:bold"><?php echo $pageName; ?></font></td> 
        </tr> 
        <tr> 
          <td height="100%" align="left" valign="top">
<?php
//if we've been passed an 'id', post it to ourselves (again)
$formId = '';
if(isset($_POST['id']))
{
	$formId = '<input type="hidden" name="id" value="'.$_POST['id'].'"/>';
}

//generate day data for form (1 to 31)
$formDay = "";
for ($i = 1; $i <= 31; $i++)
{
	$formDay = $formDay . '<option value="' . $i . '"';
	if ($i == tzDate("j", time()))
	{
		$formDay = $formDay . ' selected=""';
	}

	$formDay = $formDay . ">" . $i . "</option>\n";
}

//generate month data for form
$monthName = array('January','February','March','April','May','June','July','August','September','October','November','December');
$formMonth = '';
for ($i = 1; $i <= 12; $i++)
{
	$formMonth = $formMonth . '<option value="' . $i . '"';
	if ($i == tzDate("m", time()))
	{
		$formMonth = $formMonth . ' selected=""';
	}

	$formMonth = $formMonth . ">" . $monthName[$i-1] . "</option>\n";
}

//generate year data for form
$formYear = "";
for ($i = gmdate("Y"); $i <= gmdate("Y") + 8; $i++)
{
	$formYear = $formYear . '<option value="' . $i . '">' . $i . '</option>' . "\n";
}

//generate users data for form
$query = $db_object->query("SELECT username, id FROM " . $usersTable . "
							WHERE id != '".$_SESSION['id']."' ORDER BY username");
if (DB::isError($query))
{
	die($query->getMessage());
}
$formUsers = "";
while ($row = $query->fetchRow())
{
	$formUsers .= '<option value="'.$row['id'].'">'.$row['username']."</option>\n";
}

$formML = '
<form action="' . $_SERVER['PHP_SELF'] . '" method="post">
<errorlist>
<ul>
<erroritem> <li><message /></li>
</erroritem></ul>
</errorlist>
<table width="100%" border="0">
<tr>
<td width="50%">

<label>Title: </label>
<br/>
<input type="text" name="title" id="title" compulsory="yes" maxlength="30" size="30"/>
<error for="title"> <strong class="error">!</strong></error>
<errormsg field="title" test="compulsory">You must enter a title</errormsg>
<br/><br/>

</td>
<td width="50%">

<label>Date: </label>
<br/>
<select name="month">
' . $formMonth . '
</select>
<select name="day">
' . $formDay . '
</select>
<select name="year" callback="checkDay">
' . $formYear . '
</select>
<error for="year"><strong class="error">!</strong></error>
<errormsg field="year" test="callback">You have entered an invalid date</errormsg>
<br/><br/>

</td>
</tr>
</table>
<table width="100%" border="0">
<tr>
<td width="50%">

<label>Start Time: </label>
<br/>
<select name="startHour">
<option value="1">1</option>
<option value="2">2</option>
<option value="3">3</option>
<option value="4">4</option>
<option value="5">5</option>
<option value="6">6</option>
<option value="7">7</option>
<option value="8">8</option>
<option value="9">9</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
</select>
<select name="startMinute">
<option value="00">00</option>
<option value="15">15</option>
<option value="30">30</option>
<option value="45">45</option>
</select>
<select name="startAMPM">
<option value="AM">AM</option>
<option value="PM">PM</option>
</select>
<br/><br/>

</td>
<td width="35%">

<label>End Time: </label>
<br/>
<select name="endHour">
<option value="1">1</option>
<option value="2">2</option>
<option value="3">3</option>
<option value="4">4</option>
<option value="5">5</option>
<option value="6">6</option>
<option value="7">7</option>
<option value="8">8</option>
<option value="9">9</option>
<option value="10">10</option>
<option value="11">11</option>
<option value="12">12</option>
</select>
<select name="endMinute">
<option value="00">00</option>
<option value="15">15</option>
<option value="30">30</option>
<option value="45">45</option>
</select>
<select name="endAMPM">
<option value="AM">AM</option>
<option value="PM">PM</option>
</select>
<br/><br/>

</td>
<td width="15%" rowspan="2" valign="top">

<label>Users: </label>
<br/>
<select multiple="" size="5" name="users[]">
'.$formUsers.'
</select>
<br/>

</td>
</tr>
<tr>
<td width="50%">

<label>Location: </label>
<br/>
<input type="text" name="location" id="location" maxlength="30" size="30"/>
<br/><br/>

</td>
<td width="35%">

<label>Color: </label>
<br/>
<select name="color">
<option value="999999">Default</option>
<option value="FF0000">Red</option>
<option value="FF9900">Orange</option>
<option value="FFFF00">Yellow</option>
<option value="00FF00">Green</option>
<option value="00FFFF">Cyan</option>
<option value="0000FF">Blue</option>
<option value="9900CC">Purple</option>
</select>
<br/><br/>

</td>
</tr>
</table>

<label>Description: </label>
<br/>
<textarea type="text" name="description" id="description" rows="3" cols="64"></textarea>
<br/>

'.$formId.'
<input type="hidden" name="submit" value=""/>

<p>
<input type="submit" value="Submit"/>
</p>
</form>
';

function checkDay()
{
	return checkdate($_POST['month'], $_POST['day'], $_POST['year']);
}

$processor = new FormProcessor($formML);

//if values look good, and this is being submitted (they have already edited it)
if ($processor->validate() && isset($_POST['submit']))
{
	// escape input (unless 'magic quotes' has already done it for us)
	if (!get_magic_quotes_gpc())
	{
		$_POST['title'] = addslashes($_POST['title']);
		$_POST['description'] = addslashes($_POST['description']);
		$_POST['location'] = addslashes($_POST['location']);
		$_POST['year'] = addslashes($_POST['year']);
		$_POST['month'] = addslashes($_POST['month']);
		$_POST['day'] = addslashes($_POST['day']);
		$_POST['startHour'] = addslashes($_POST['startHour']);
		$_POST['startMinute'] = addslashes($_POST['startMinute']);
		$_POST['startAMPM'] = addslashes($_POST['startAMPM']);
		$_POST['endHour'] = addslashes($_POST['endHour']);
		$_POST['endMinute'] = addslashes($_POST['endMinute']);
		$_POST['endAMPM'] = addslashes($_POST['endAMPM']);
		$_POST['color'] = addslashes($_POST['color']);
		$_POST['users'] = addslashes($_POST['users']);
	}
	
	$date = $_POST['year'] . "-" . $_POST['month'] . "-" . $_POST['day'];
	
	$startTS = strtotime($_POST['startHour'] . ":" . $_POST['startMinute'] . ":00" . $_POST['startAMPM']);
	$startDT = $date . " " . date("H:i:00", $startTS);
	
	$endTS = strtotime($_POST['endHour'] . ":" . $_POST['endMinute'] . ":00" . $_POST['endAMPM']);
	$endDT = $date . " " . date("H:i:00", $endTS);
	
	$_POST['users'][] = $_SESSION['id']; //add this users id to the list of users this event is for
		
	//if we are editing, the id is passed, so UPDATE the entry
	if(isset($_POST['id']))
	{
		$sql = "UPDATE ".$eventsTable."
				SET
				title='".$_POST['title']."',
				description='".$_POST['description']."',
				location='".$_POST['location']."',
				startDT=DATE_ADD('".$startDT."', INTERVAL '".($_SESSION['tz'] * -1)."' MINUTE),
				endDT=DATE_ADD('".$endDT."', INTERVAL '".($_SESSION['tz'] * -1)."' MINUTE),
				color='".$_POST['color']."'
				WHERE id='".$_POST['id']."'
				AND owner='".$_SESSION['id']."'";
		//run the query
		$query = $db_object->query($sql);
		if (DB::isError($query))
		{
			die($query->getMessage());
		}
		
		//delete link between this event and all users
		$sql = "DELETE FROM " . $attendanceTable . "
				WHERE eid=".$_POST['id'];
		//run the query
		$query = $db_object->query($sql);
		if (DB::isError($query))
		{
			die($query->getMessage());
		}
		
		//add link between this event and the selected users + this user
		reset($_POST['users']);
        while(list($key, $val) = each($_POST['users']))
		{
			$sql = "INSERT INTO " . $attendanceTable . "
					VALUES (".$_POST['id'].", ".$val.");";
			//run the query
			$query = $db_object->query($sql);
			if (DB::isError($query))
			{
				die($query->getMessage());
			}
        }
	}
	else
	{	
		//else add the event to the database
		$sql = "INSERT INTO " . $eventsTable . " () VALUES (
				'',
				'".$_SESSION['id']."',
				'".$_POST['title']."',
				'".$_POST['description']."',
				'".$_POST['location']."',
				DATE_ADD('".$startDT."', INTERVAL '".($_SESSION['tz'] * -1)."' MINUTE),
				DATE_ADD('".$endDT."', INTERVAL '".($_SESSION['tz'] * -1)."' MINUTE),
				'".$_POST['color']."'
				);";
		//run the query
		$query = $db_object->query($sql);
		if (DB::isError($query))
		{
			die($query->getMessage());
		}
		
		//add link between this event and the selected users + this user
        reset($_POST['users']);
		while(list($key, $val) = each($_POST['users']))
		{
			$sql = "INSERT INTO " . $attendanceTable . "
					VALUES (LAST_INSERT_ID(), ".$val.");";
			echo $sql;
			//run the query
			$query = $db_object->query($sql);
			if (DB::isError($query))
			{
				die($query->getMessage());
			}
        }
	}
	$db_object->disconnect();

//Item was sucessfully added or updated - refresh opener and close
?>
<script language="javascript">
	window.opener.location.reload();
	window.close();
</script>
<?php
}
//if values are bad, or user needs to edit
else
{
    //show the form
	$processor->display();
}
?></td>
  </tr> 
  <tr align="center" valign="middle"> 
    <td><?php include 'cgi-bin/footer.inc.php'; ?></td> 
  </tr> 
</table>
</body>
</html>
<?php
}
?>